package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMAssessMentMX;
import cn.ibizlab.eam.core.eam_core.filter.EMAssessMentMXSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMAssessMentMX] 服务对象接口
 */
public interface IEMAssessMentMXService extends IService<EMAssessMentMX>{

    boolean save(EMAssessMentMX et) ;
    void saveBatch(List<EMAssessMentMX> list) ;
    boolean update(EMAssessMentMX et) ;
    void updateBatch(List<EMAssessMentMX> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMAssessMentMX et) ;
    boolean create(EMAssessMentMX et) ;
    void createBatch(List<EMAssessMentMX> list) ;
    EMAssessMentMX getDraft(EMAssessMentMX et) ;
    EMAssessMentMX get(String key) ;
    Page<EMAssessMentMX> searchDefault(EMAssessMentMXSearchContext context) ;
    List<EMAssessMentMX> selectByEmassessmentid(String emassessmentid) ;
    void removeByEmassessmentid(String emassessmentid) ;
    List<EMAssessMentMX> selectByPfempid(String pfempid) ;
    void removeByPfempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMAssessMentMX> getEmassessmentmxByIds(List<String> ids) ;
    List<EMAssessMentMX> getEmassessmentmxByEntities(List<EMAssessMentMX> entities) ;

}


